package ru.dbotthepony.mc.otm.menu;

import net.minecraft.world.Container;
import net.minecraft.world.SimpleContainer;
import net.minecraft.world.entity.player.Inventory;
import net.minecraft.world.item.ItemStack;
import ru.dbotthepony.mc.otm.MatterRegistry;
import ru.dbotthepony.mc.otm.Registry;
import ru.dbotthepony.mc.otm.block.entity.BlockEntityMatterDecomposer;
import ru.dbotthepony.mc.otm.capability.MatteryCapability;
import ru.dbotthepony.mc.otm.menu.slot.MachineInputSlot;
import ru.dbotthepony.mc.otm.menu.slot.MachineOutputSlot;
import ru.dbotthepony.mc.otm.menu.widget.MatterLevelWidget;
import ru.dbotthepony.mc.otm.menu.widget.ProgressGaugeWidget;

import javax.annotation.Nullable;

public class MatterDecomposerMenu extends PoweredMatteryMenu {
	public MatterDecomposerMenu(int containerID, Inventory inventory) {
		this(containerID, inventory, null);
	}

	public MatterLevelWidget<PoweredMatteryMenu> matter_widget;
	public ProgressGaugeWidget<PoweredMatteryMenu> progress_widget;

	public MatterDecomposerMenu(int containerID, Inventory inventory, @Nullable BlockEntityMatterDecomposer tile) {
		super(Registry.Menus.MATTER_DECOMPOSER, containerID, inventory, tile);
		Container container = tile != null ? tile.item_container : new SimpleContainer(2);

		// Вход
		addSlot(new MachineInputSlot(container, 0, 61, 36) {
			@Override
			public boolean mayPlace(ItemStack p_40231_) {
				return MatterRegistry.hasMatterValue(p_40231_);
			}
		});

		// Выход
		addSlot(new MachineOutputSlot(container, 1, 61 + 18 + 10 + 3 + 22, 36, true, true));

		if (tile == null || tile.getCapability(MatteryCapability.MATTER).resolve().isEmpty()) {
			matter_widget = new MatterLevelWidget<>(this, 22, 14);
			progress_widget = new ProgressGaugeWidget<>(this, 61 + 18 + 3, 36);
		} else {
			matter_widget = new MatterLevelWidget<>(this, 22, 14, tile.getCapability(MatteryCapability.MATTER).resolve().get());
			progress_widget = new ProgressGaugeWidget<>(this, 61 + 18 + 3, 36, () -> (float) tile.getWorkProgress());
		}

		addBatterySlot(14);
		addInventorySlots();
	}

	@Override
	protected int getWorkingSlotStart() {
		return 0;
	}

	@Override
	protected int getWorkingSlotEnd() {
		return 1;
	}
}
